﻿using System.Collections.Generic;
using System.IO;
using System.Text;

namespace TI83PlusBootExec {
	internal class GroupFile {

		public List<Variable> Variables {
			get;
			private set;
		}

		public string Comment { get; set; }
		
		public GroupFile() {
			this.Variables = new List<Variable>();
		}

		public GroupFile(BinaryReader binaryReader) : this() {

			if (Encoding.ASCII.GetString(binaryReader.ReadBytes(8)) != "**TI83F*") throw new InvalidDataException();

			var signature = binaryReader.ReadBytes(3);

			this.Comment = Encoding.ASCII.GetString(binaryReader.ReadBytes(42)).Split('\0')[0].TrimEnd(' ');

			var size = binaryReader.ReadUInt16();

			var data = binaryReader.ReadBytes(size);

			var dataStream = new MemoryStream(data);
			using (var dataReader = new BinaryReader(dataStream)) {
				while (dataStream.Position != data.Length) {
					this.Variables.Add(new Variable(dataReader));
				}
			}

		}

    }
}
