﻿using System;

namespace TI83PlusBootExec {
	internal abstract class LinkCable {

		private TimeSpan timeout;
		public TimeSpan Timeout {
			get { return timeout; }
			set { timeout = value; }
		}

		public LinkCable() {
			this.timeout = TimeSpan.FromSeconds(2);
		}

		public abstract bool TryReadByte(out byte value);
		public abstract bool TryWriteByte(byte value);

		public virtual bool TryWriteBytes(byte[] values) {
			foreach (var value in values) {
				if (!this.TryWriteByte(value)) {
					return false;
				}
			}
			return true;
		}

		public virtual bool TryReadBytes(out byte[] values, int count) {
			values = new byte[count];
			for (int i = 0; i < count;) {
				byte b;
				if (!this.TryReadByte(out b)) {
					return false;
				} else {
					values[i++] = b;
				}
			}
			return true;
		}
	}

}
