﻿using System.IO;

namespace TI83PlusBootExec {
	internal class Variable {

		public byte Type { get; set; }
		public byte[] Name { get; set; }
		public byte[] Data { get; set; }

		public Variable() { }

		public Variable(BinaryReader binaryReader) {
			
			var headerSize = binaryReader.ReadUInt16();
			
			var sizeA = binaryReader.ReadUInt16();
			this.Type = binaryReader.ReadByte();
			this.Name = binaryReader.ReadBytes(8);

			if (headerSize > 11) binaryReader.ReadUInt16();

			var sizeB = binaryReader.ReadUInt16();

			if (sizeA != sizeB) {
				throw new InvalidDataException();
			}

			var sizeC = binaryReader.ReadUInt16();

			this.Data = binaryReader.ReadBytes(sizeC);
		}


    }
}
